// Pin vergabe, welche als Konstante im Programm
const int stepPIN_L = 3,
          stepPIN_DIR_L = 2,

          stepPIN_R = 5,
          stepPIN_DIR_R = 6,

          photoLEDlight_PinR = 11,
          photoLEDlight_PinL = 10,

          transistorPIN_R = A7,
          transistorPIN_L = A6,

          throwPIN = 8,

          leftLineVal = 250,
          rightLineVal = 250;

bool thrown = false; //Roboter Status, welcher verhindert, dass zwei mal geworfen wird und das es kein Ende gibt.
bool  done = false;
#include "lineRecog.h"
void setup() {
  // put your setup code here, to run once:
  initializePINS(); //Pins werden initalisiert(aus Output gesetzt etc.)
  changePhotolight(true); //Die LED für den "Farbsensor" werden angemacht.
  Serial.begin(9600);
}


void loop() {
//Test Zeilen um die Transistorwerte zu trimmen.
//   Serial.println("R:\t" + String(analogRead(transistorPIN_R)));
//   Serial.println("L:\t" + String(analogRead(transistorPIN_L)));

// Hauptfunktionsbereich
  if (!done) {
    moveSteps(10); //Roboter beginnt mit fährt immer geradeaus, falls nichts anderes passiert.
    switch (checkLineR()) { //Zuerst wird der eine Phototransistor gecheckt.
      case 0:
        Serial.println("R case 0");
        //Wenn keine Linie gefunden wird geht es wieder von vorne los.
        break;
      case 1:
        Serial.println("R case 1");
        delay(1000);
        positionToThrowR(); // Roboter bleibt stehen und positioniert sich mit beiden Sensoren auf der Linie, um dann zu werfen.
        done = true;
        break;
      case 2:
        Serial.println("R case 2");
        //turn(-90);
        break;
    }
    switch (checkLineL()) { //Analog das geiche für den linken Transistor
      case 0:
        Serial.println("L case 0");
        break;
      case 1:
        Serial.println("L case 1");
        delay(1000);
        positionToThrowL();
        done = true;
        break;
      case 2:
        Serial.println("L case 2");
        //turn(90);
        break;
    }
  }

}

void moveSteps(int steps) { // Funktion, die den Roboter gereade aus fahren lässt
  for (int i = 0; i < steps; i++) { 
    // Wir haben nicht die Standardbibliothek genommen, da diese bei uns nicht funktioniert hat.
    digitalWrite(stepPIN_L, HIGH);
    digitalWrite(stepPIN_R, HIGH);
    delay(1);

    digitalWrite(stepPIN_L, LOW);
    digitalWrite(stepPIN_R, LOW);
    delay(1);
  }
}

void moveSteps(int steps, int stepPIN) { // Funktion überlauf, womit auch nur ein Stepper angesteuert werden kann, welcher dann vorwärts läuft.
  for (int i = 0; i < steps; i++) { 
    digitalWrite(stepPIN, HIGH);
    delay(1);
    digitalWrite(stepPIN, LOW);
    delay(1);
  }
}


void positionToThrowR() {
  while (analogRead(transistorPIN_L) >= leftLineVal || analogRead(transistorPIN_R) >= rightLineVal) { //Checken ob einer der beiden Sensoren sich nicht auf der Linie befindet.
    while (analogRead(transistorPIN_L) >= leftLineVal) { // Falls der linke sich nicht auf der Linie befindet, fährt der linke Stepper nache vorne.
      Serial.println("Move Steps L");
      moveSteps(1, stepPIN_L);                                                   
    }
    while (analogRead(transistorPIN_R) >= rightLineVal) { // Analog wie bei links, nur mit rechts.

      Serial.println("Move Steps R");
      moveSteps(1, stepPIN_R);
    }

  }
  if (analogRead(transistorPIN_L) >= leftLineVal && analogRead(transistorPIN_R) >= rightLineVal && !thrown) { // Falls beide sich auf der Linie befinden und der Ball noch nicht geworfen wurde, wird er dann abgeworfen
    delay(1000);
    Serial.println("THROW!!");
    throwBall();
    thrown = true; // Änderung des Status für den Wurf
  }
}

// Analog zu positionToThrowR()
void positionToThrowL() {
  while (analogRead(transistorPIN_R) <= rightLineVal || analogRead(transistorPIN_L) <= leftLineVal) {
    while (analogRead(transistorPIN_L) <= leftLineVal) {
      Serial.println("Move Steps L");
      moveSteps(1, stepPIN_L);
    }
    while (analogRead(transistorPIN_R) <= rightLineVal) {
      Serial.println("Move Steps R");
      moveSteps(1, stepPIN_R);                                                   
    }
  }
  if (analogRead(transistorPIN_R) >= rightLineVal && analogRead(transistorPIN_L) >= leftLineVal && !thrown) {
    delay(1000);
    Serial.println("THROW!!");
    throwBall();
    thrown = true;
  }
}

void throwBall() { // Hubmagnet wird ausgelöst um den Katapult zu starten.
  digitalWrite(throwPIN, HIGH);
  delay(1000);
  digitalWrite(throwPIN, LOW);
  delay(1000);
}

void initializePINS() {
  //Stepper Pins
  pinMode(stepPIN_DIR_L, OUTPUT);
  pinMode(stepPIN_L, OUTPUT);
  digitalWrite(stepPIN_DIR_L, HIGH);

  pinMode(stepPIN_DIR_R, OUTPUT);
  pinMode(stepPIN_R, OUTPUT);
  digitalWrite(stepPIN_DIR_R, LOW);

  //photosensor Pins
  pinMode(photoLEDlight_PinR, OUTPUT);
  pinMode(photoLEDlight_PinL, OUTPUT);

  pinMode(throwPIN, OUTPUT);

}
